import javax.swing.*;
import java.awt.image.*;
import java.awt.Graphics;
import java.awt.Dimension;

class ContexteGraphique extends JPanel implements Runnable
{
    private BufferedImage renduVisuel;
    private AutomateCellulaire ac;
    private Thread threadDeMiseAJour;
    private boolean misAJour = true;

    ContexteGraphique(BufferedImage renduVisuel,AutomateCellulaire ac) 
    {
	super();
	this.renduVisuel = renduVisuel;
	this.ac = ac;
	setPreferredSize(new Dimension(renduVisuel.getWidth(),renduVisuel.getHeight()));
	// instanciation et lancement du thread courant charg du
	// rafrachissement de l'image :
	threadDeMiseAJour = new Thread(this);
	threadDeMiseAJour.setPriority(Thread.MAX_PRIORITY);
	threadDeMiseAJour.start();
    }

    synchronized public void setMisAJour(boolean valeur) 
    {
        misAJour = valeur;
    }

    synchronized public boolean getMisAJour() 
    {
        return misAJour;
    }

    public void paintComponent(Graphics g)
    {
	super.paintComponent(g);
	g.drawImage(renduVisuel,0,0,this);
    }

    public void run()
    {
	while (true) {
	    try {
		// endormir le thread courant pendant une priode de quelques
		// millisecondes (pour ne pas perturber l'application de la
		// fonction de transition globale du rseau d'automates
		// cellulaires) :
		threadDeMiseAJour.sleep(300);
	    } catch (InterruptedException uneException) {}
	    // puis procder, si ncessaire,  la mise  jour de
	    // l'affichage graphique :
	    if (ac.getMisAJour() && this.getMisAJour()) {
		repaint();
		ac.setMisAJour(false);
	    }
	}
	
    }
}
