import javax.swing.*;
import java.awt.image.*;
import java.awt.event.*;
import java.awt.Graphics;

class FeuDeForetGraphique extends JFrame implements ActionListener
{
    private ContexteGraphique animation;
    private AutomateCellulaire ac;
    private JMenuItem reprendre,suspendre;

    FeuDeForetGraphique(BufferedImage renduVisuel,AutomateCellulaire ac) {
	// on cre la fentre par appel au constructeur de la classe
	// mre JFrame :
	super("Simulation d'un feu de fort");
      	setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE); 
	// on enrichit la fentre courante d'une barre de menus
	// compose d'un seul menu droulant :
	JMenuBar barreDeMenus = new JMenuBar();
	JMenu leMenu = new JMenu("Application");

	reprendre = new JMenuItem("Reprendre la simulation");
	suspendre = new JMenuItem("Suspendre la simulation");
        JMenuItem terminer = new JMenuItem("Terminer la simulation");

	// on dsactive le choix "reprendre la simulation" :
	reprendre.setEnabled(false);
	
	// on dfinit les actions associes  chaque "choix" du menu
	// droulant...
	reprendre.setActionCommand("1");
	suspendre.setActionCommand("2");
	terminer.setActionCommand("3");
	// ... et on les "attache"  la fentre courante :
	reprendre.addActionListener(this);
	suspendre.addActionListener(this);
	terminer.addActionListener(this);

	// on attache les divers choix au menu droulant "leMenu",
	// puis on lie "leMenu"  "barreDeMenus" d'une part et
	// "barreDeMenus"  la fentre courante d'autre part :
        leMenu.add(reprendre);
        leMenu.add(suspendre);
        leMenu.addSeparator();
        leMenu.add(terminer);
	barreDeMenus.add(leMenu);
	setJMenuBar(barreDeMenus);

	// on associe la variable d'instance ac  l'automate
	// cellulaire pass en argument de constructeur :
	this.ac = ac;

	// on attache le "ContexteGraphique" appel "animation"  la
	// fentre courante :
	animation = new ContexteGraphique(renduVisuel,ac);
	getContentPane().add(animation);

	// enfin, on procde  l'affichage de l'ensemble :
	pack();
	setVisible(true);
    }

    public void actionPerformed(ActionEvent vnement)
    {
	// cette mthode permet de grer les vnements survenus au
	// cours de l'excution de cette classe :
	switch (Integer.parseInt(vnement.getActionCommand())) {
	case 1:
            // ordre de reprise de la simulation :
	    System.out.println("Reprise de la simulation...");
	    reprendre.setEnabled(false);
	    suspendre.setEnabled(true);
	    ac.setMisAJour(false);
	    animation.setMisAJour(true);
	    break;
	case 2:
            // ordre de suspension de la simulation :	    
	    System.out.println("Arrt sur image...");
	    reprendre.setEnabled(true);
	    suspendre.setEnabled(false);
	    ac.setMisAJour(true);
	    animation.setMisAJour(false);
	    break;
	case 3:
	    System.out.println("Merci,  bientt !");
	    setVisible(false);
	    dispose();
	    System.exit(0);
	    break;
	}
    }

    public static void main (String[] arguments)
    {
	int nbc = Integer.parseInt(arguments[0]);
        int nbl = Integer.parseInt(arguments[1]);

        BufferedImage renduVisuelDeLaSimulation = 
            new BufferedImage(nbc,nbl,BufferedImage.TYPE_INT_RGB);
	// instanciation et lancement du rseau d'automates cellulaires et de
	// l'interface graphique :
        new FeuDeForetGraphique(renduVisuelDeLaSimulation,
				new AutomateCellulaire(nbc,nbl,renduVisuelDeLaSimulation));
    }
}
