import javax.swing.*;
import java.awt.*;
import java.awt.event.*;

class ArdoiseMagique
{
    JFrame laFentre;

    class ArdoiseGraphique extends JPanel implements MouseListener
    {
	Point pointPrcdent = new Point(200,100), pointCourant = pointPrcdent;
	char choix = 'l';

	ArdoiseGraphique()
	{
	    // on redimensionne le composant courant :
	    setPreferredSize(new Dimension(400,200));
	    // on lui associe un rcepteur d'"vnements souris" :
	    addMouseListener(this);
	}

	public void paintComponent(Graphics g) {
	    /* en fonction de la valeur du paramtre "choix", on peut soit,
	     * tracer une ligne entre le "pointPrcdent" et le
	     * "pointCourant", soit tracer un disque de 5 pixels de rayon
	     * centr au "pointCourant", soit enfin, r-initialiser
	     * l'affichage : */
	    switch (choix) {
	    case 'l':
		g.drawLine(pointPrcdent.x, pointPrcdent.y, pointCourant.x, pointCourant.y);
		break;
	    case 'c':
		g.fillOval(pointCourant.x-5,pointCourant.y-5,10,10);
		break;
	    case 'r':
		super.paintComponent(g);
		break;
	    }
	}

	public void mouseClicked(MouseEvent vnement)
	{
	    // on rceptionne et traite, au sein de cette mthode, un clic
	    // souris (qu'il s'agisse du bouton de gauche, du milieu ou de
	    // droite...) :
	    int drapeau = vnement.getModifiers();
	    // la variable "drapeau" permet d'identifier le type de
	    // "clic souris" dont il s'agit :
	    if ((drapeau & MouseEvent.BUTTON1_MASK) != 0) {
		choix = 'l';
		pointPrcdent = pointCourant;
		pointCourant = vnement.getPoint();
	    }
	    else if ((drapeau & MouseEvent.BUTTON2_MASK) != 0)
		choix = 'c';
	    else if ((drapeau & MouseEvent.BUTTON3_MASK) != 0)
		choix = 'r';
	    // l'invocation de la mthode repaint permet d'activer le
	    // rafrachissement de l'affichage par le biais de la mthode
	    // paintComponent dfinie ci-dessus :
 	    repaint();	    
	}
	public void mouseEntered(MouseEvent vnement) {}
	public void mouseExited(MouseEvent vnement) {}
	public void mousePressed(MouseEvent vnement) {}
	public void mouseReleased(MouseEvent vnement)	{}
    }
    // constructeur de la classe englobante :
    ArdoiseMagique()
    {
	// on commence par crer la fentre et lui dfinir un comportement 
	// la fermeture ( l'aide d'une classe anonyme) :
	laFentre = new JFrame("Mon ardoise magique...");
	// ce qui suit peut-tre abrg, avec la version 1.3 du langage, par :
	// laFentre.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
	laFentre.addWindowListener(new WindowAdapter() {
	    public void windowClosing(WindowEvent vnement)
		{
		    laFentre.setVisible(false);
		    laFentre.dispose();
		    System.exit(0);
		}
	});
	// on instancie une "ArdoiseGraphique" que l'on attache  "laFentre" :
	laFentre.setContentPane(new ArdoiseGraphique());
	// enfin, on procde  l'affichage de l'ensemble :
        laFentre.pack();
        laFentre.setVisible(true);
    }

    public static void main (String[] arguments) throws Exception
    {
	// on lance l'application en instanciant la classe englobante
	// ArdoiseMagique :
	new ArdoiseMagique();
    }
}
