import java.util.Properties;
import java.util.Enumeration;
import java.io.IOException;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.BufferedReader;
import java.io.InputStreamReader;

class CodesDePays
{    
    Properties lesCodes;

    CodesDePays()
    {
	lesCodes = new Properties();
    }

    void chargerLesCodesDePays(String nomFichier)
    {
	try {
	    FileInputStream entre = new FileInputStream(new File(nomFichier));
	    // chargement de la table des proprits depuis un fichier du disque :
	    lesCodes.load(entre);
	    System.out.println("Chargement de la table des codes termin.");
	}
	catch (IOException e) {
	    System.err.println("Pas de chargement de la table des codes...");
	}
    }

    void insererCodes()
    {
	String codePays,nomPays;
	boolean continuer = true;
	// dfinissons le tampon de lecture de l'entre standard :
	BufferedReader stdin = new BufferedReader(new InputStreamReader(System.in));
	do {
	    try {
		System.out.print("Entrez le code pays (ou retour chariot pour terminer) : ");
		codePays = stdin.readLine();
		System.out.print("Entrez le nom du pays (ou retour chariot pour terminer) : ");
		nomPays = stdin.readLine();
		// si l'une des deux chanes est vide, on s'arrte :
		if (! codePays.equalsIgnoreCase("") && ! nomPays.equalsIgnoreCase(""))
		    lesCodes.setProperty(codePays,nomPays);
		else continuer = false;
	    }
	    catch (IOException e) {
		System.err.println("Problme  la lecture des donnes en entre !");
	    }
	} while (continuer);
    }

    void afficher()
    {
	System.out.println("Contenu de la table des codes/noms de pays :");
	// utilisation d'une numration :
	Enumeration numrationDesCodes = lesCodes.propertyNames();
	while (numrationDesCodes.hasMoreElements()) {
	    String clef = (String) numrationDesCodes.nextElement();
	    System.out.println(clef + " " + lesCodes.getProperty(clef));
	}
	// nous aurions pu simplement appeler : lesCodes.list(System.out);
    }

    void enregistrerLesCodesDePays(String nomFichier)
    {
	try {
	    FileOutputStream sortie = new FileOutputStream(new File(nomFichier));
	    // enregistrement de la table des proprits dans un fichier sur le disque :
	    lesCodes.store(sortie,"Codes de pays  la date du...");
	    System.out.println("Enregistrement de la table des codes termin.");
	}
	catch (IOException e) {
	    System.err.println("Problme  l'enregistrement de la table des codes...");
	}
    }

    public static void main (String[] arguments) 
    {
	// cration de la table de codes pays :
	CodesDePays tab = new CodesDePays();
	// chargement du fichier des codes pays (s'il existe) :
	tab.chargerLesCodesDePays("codesPays.txt");	
	// insertion de nouveaux codes de pays :
	tab.insererCodes();
	tab.afficher();
	// enrichissement du fichier des codes pays :
	tab.enregistrerLesCodesDePays("codesPays.txt");
    }
}
