import java.util.Enumeration;
import java.util.Hashtable;
import java.io.StreamTokenizer;
import java.io.File;
import java.io.FileReader;

public class DecompteDesMotsDUnTexte
{
    StreamTokenizer fluxEntrant;
    Hashtable tableDesMots;

    DecompteDesMotsDUnTexte (String nomDeFichier) throws java.io.FileNotFoundException
    {
	tableDesMots = new Hashtable();
	// initialisation du flux entrant :
	fluxEntrant = new StreamTokenizer(new FileReader(new File(nomDeFichier)));
	fluxEntrant.ordinaryChar('.');
    }

    void traitement () throws java.io.IOException
    {
	Integer tmp, un = new Integer(1);
	// parcours du flux en entre et traitement de chaque mot par initialisation 
	// ou incrmentation de son compteur d'occurrences :
	while (fluxEntrant.nextToken() != StreamTokenizer.TT_EOF) {
	    if (fluxEntrant.ttype == StreamTokenizer.TT_WORD) {
		Object djaEnregistr = tableDesMots.get(fluxEntrant.sval);
		// test pour vrifier si l'objet (le mot) existe dj en tant que
		// clef dans la table de hachage :
		if (djaEnregistr == null) 
		    // le compteur du mot est initialis  1 :
		    tmp = un;
		else 
		    // le compteur du mot est incrment d'une unit :
		    tmp = new Integer(Integer.parseInt(djaEnregistr.toString()) + 1);
		// le couple mot/compteur est r-introduit dans la table :
		tableDesMots.put(fluxEntrant.sval, tmp);
	    }
	}
    }

    void affichage ()
    {
	// numration des lments de la liste par le biais d'une Enumration :
	Enumeration laListe = tableDesMots.keys();
	while (laListe.hasMoreElements()) {
	    String clef = laListe.nextElement().toString();
	    System.out.println( clef + " (" + tableDesMots.get(clef) + " occurrences)" );
	}
    }

    public static void main (String[] arguments) throws java.io.IOException
    {
	// on passe en argument de la ligne de commande le nom du fichier  traiter :
	DecompteDesMotsDUnTexte toto = new DecompteDesMotsDUnTexte(arguments[0]);
	toto.traitement();
	toto.affichage();
    }
}
