import java.util.Stack;
import java.util.EmptyStackException;
import java.io.BufferedReader;
import java.io.InputStreamReader;
import java.io.IOException;

class Parenthesage
{
    String expression;
    Stack pileDesParenthses;

    Parenthesage (String uneExpression)
    {
	// initialisons l'expression et instancions la pile des parenthses :
	expression = uneExpression;
	pileDesParenthses = new Stack();
    }
    
    boolean valide ()
    {
	try {
	    // parcourons un  un chacun des caractres de l'expression
	    for (int i=0 ; i<expression.length() ; i++) {
		switch (expression.charAt(i)) {
		case '(':
		    // si le caractre courant est une parenthse ouvrante, on l'empile :
		    pileDesParenthses.push(new Character('('));
		    break;
		case ')':
		    // si le caractre courant est une parenthse fermante, on considre que
		    // celle-ci referme une parenthse ouverte prcdemment et on la dpile :
		    pileDesParenthses.pop();
		    break;
		}
	    }
	}
	catch (EmptyStackException e) {
	    // dpiler une pile vide provoque la leve d'une exception de type 
	    // EmptyStackException. Si c'est le cas c'est que dans l'expression, il y a au
	    // moins une parenthse fermante qui n'a pas t ouverte au pralable :
	    return false;
	}
	// si la "pileDesParenthses" est vide en sortie, cela signifie que le parenthsage 
	// est correct puisque toutes les parenthses ouvertes sont refermes. Sinon le 
	// parenthsage est incorrect :
	if (pileDesParenthses.empty())
	    return true;
	else return false;
    }
    
    public static void main (String[] arguments)
    {
        try {
	    // dfinissons le tampon de lecture de l'entre standard :
	    BufferedReader stdin = new BufferedReader(new InputStreamReader(System.in));
	    // instancions un nouvel objet de type Parenthesage :
	    System.out.print("Entrez votre expression  valider : ");
	    Parenthesage laChane = new Parenthesage(stdin.readLine());
	    // validons l'expression associe  cet objet du point de vue du parenthsage :
	    if (laChane.valide())
		System.out.println("=> expression bien parenthse !");
	    else System.out.println("=> expression mal parenthse !");
	}
	catch (IOException e) {
	    System.err.println("Problme  la saisie de l'expression !");
	}
    }
}
