import java.io.BufferedReader;
import java.io.InputStreamReader;
import java.io.IOException;

class DivisionEuclidienneAvecThrows
{
    final static int TAILLETABLEAU = 10;
    int[] tableauDeValeurs = new int[TAILLETABLEAU];
    
    private int saisie (BufferedReader entre) throws IOException,ArrayIndexOutOfBoundsException
    {
	String tmp="";
        int i = 0;
        while (true) {
            System.out.print("Entrez un entier (ou fin pour terminer) : ");
            try {
		tmp = entre.readLine();
		if (tmp.equalsIgnoreCase("fin"))
		    return i;
                tableauDeValeurs[i++] = Integer.parseInt(tmp);
            }
            catch (NumberFormatException e) {
                i--;
		System.err.println("Attention, il faut entrer des valeurs entires !");
            }
        }
    }

    private String calculs (int nbTermes) throws ArithmeticException
    {
        String chaneSomme = "(", chaneProduit = "(";
        long somme = 0, produit = 1;
        for(int i=0 ; i<nbTermes ; i++) {
            chaneSomme += tableauDeValeurs[i] + "+";
            chaneProduit += tableauDeValeurs[i] + "*";
            somme += tableauDeValeurs[i];
            produit *= tableauDeValeurs[i];
        }
        chaneSomme = chaneSomme.substring(0,chaneSomme.length()-1) + ")";
        chaneProduit = chaneProduit.substring(0,chaneProduit.length()-1) + ")";
        return chaneProduit + " / " + chaneSomme + " = " + produit + " / "
	    + somme + " = " + produit/somme + " (reste " + produit%somme + ")" ;
    }
    
    public static void main (String[] arguments) throws IOException
    {
        DivisionEuclidienneAvecThrows toto = new DivisionEuclidienneAvecThrows();
	int nbTermes = -1;
        
        BufferedReader stdin = new BufferedReader(new InputStreamReader(System.in));
        try {
            nbTermes = toto.saisie(stdin);
        }
        catch (ArrayIndexOutOfBoundsException e) {
            System.err.println("Attention, il ne faut pas entrer plus de " + TAILLETABLEAU + " valeurs !");
        }
	try {
	    System.out.println(toto.calculs(nbTermes));
	}
	catch (ArithmeticException e) {
	    System.err.println("Attention, vous cherchez  effectuer une division par 0 !");
	}
    }
}

