import java.io.*;

class ComparaisonDesPerformances
{
    public static void main (String[] arguments) throws FileNotFoundException,IOException
    {
	int c;
	long nbCaractres1=0,nbCaractres2=0,nbCaractres3=0,nbCaractres4=0;
	long date0,date1,date2,date3,date4;
	String nomFichier = arguments[0];
	date0 = System.currentTimeMillis(); // saisie de la date courante

	// lecture non bufferise par Reader (v 1.1)
	Reader fluxEnEntre1 = new FileReader(new File(nomFichier));
	while ((c = fluxEnEntre1.read()) != -1) nbCaractres1++;
	fluxEnEntre1.close();
	date1 = System.currentTimeMillis();
	
	// lecture bufferise par BufferedReader (v 1.1)
	BufferedReader fluxEnEntre2 = new
	    BufferedReader(new FileReader(new File(nomFichier)));
  	while ((c = fluxEnEntre2.read()) != -1) nbCaractres2++;
	// String ligne; while ((ligne = fluxEnEntre2.readLine()) != null) {}
	fluxEnEntre2.close();
	date2 = System.currentTimeMillis(); // saisie de la date courante
	
	// lecture non bufferise par InputStream (v 1.0)
	InputStream fluxEnEntre3 = new FileInputStream(new File(nomFichier));
	while ((c = fluxEnEntre3.read()) != -1) nbCaractres3++;
	fluxEnEntre3.close();
	date3 = System.currentTimeMillis(); // saisie de la date courante
	
	// lecture bufferise par InputStream (v 1.0)
  	InputStream fluxEnEntre4 = new 
	    BufferedInputStream(new FileInputStream(new File(nomFichier)));
  	while ((c = fluxEnEntre4.read()) != -1) nbCaractres4++;
  	fluxEnEntre4.close();
	date4 = System.currentTimeMillis(); // saisie de la date courante
	
	// affichage du verdict :
	if ((nbCaractres1 == nbCaractres2) && (nbCaractres1 == nbCaractres3) &&
	    (nbCaractres1 == nbCaractres4)) {
	    System.out.println("Pour lire " + nbCaractres1 + " caractres, il faut...");
	    System.err.println("par Reader non bufferis : " + (date1-date0) + " ms");
	    System.err.println("par Reader bufferis : " + (date2-date1) + " ms");
	    System.err.println("par InputStream non bufferis : " + (date3-date2) + " ms");
	    System.err.println("par InputStream bufferis : " + (date4-date3) + " ms");
	}
    }
}
