import java.io.*;

class LireEntreeStandard
{
    public static void main (String[] arguments) throws IOException
    {
	/*   l'entre   standard  "System.in"   est   vue   sous  forme   d'un
	 * BufferedReader.  Si nous  avions souhait crire  ce qui suit   la
	 * mode Java 1.0, nous aurions utilis un DataInputStream comme ici :
	 * DataInputStream entre = new DataInputStream(System.in);
	 * Attention,  la mthode "readLine" de la  classe DataInputStream est
	 * appele   disparatre dans  les versions futures du  langage, elle
	 * est en effet dclare "deprecated"! */
   	BufferedReader entre = new BufferedReader(new InputStreamReader(System.in));
	/*  la   sortie  standard  "System.out"   est  vue  sous   forme  d'un
	 *  PrintWriter.  La valeur boolenne  "true" en deuxime  argument de
	 *  constructeur permet d'activer  le mcanisme automatique de "flush"
	 *   (ou auto-vidage) sur  le tampon  d'criture   chaque appel   la
	 *  mthode "println" ou  chaque tentative d'criture d'un "\n" : */
 	PrintWriter sortie = new PrintWriter(System.out,true);
	/*  la   sortie  d'erreur  "System.err"   est  vue  sous   forme  d'un
	 *  PrintWriter. La valeur  boolenne "true"  en deuxime  argument de
	 * constructeur  permet d'activer le mcanisme  automatique de "flush"
	 *  (ou auto-vidage)  sur le  tampon d'criture   chaque  appel   la
	 * mthode "println" ou  chaque tentative d'criture d'un "\n" : */
	PrintWriter erreur = new PrintWriter(System.err,true); 
	
	String ligneCourante;
	long unEntier;
	double unFlottant;
	
	sortie.println("Entrez un entier ou un flottant au clavier :");
	while ((ligneCourante = entre.readLine()) != null) {
	    try {
		// tentative de conversion en entier :
		unEntier = Long.parseLong(ligneCourante);
		sortie.println("=> " + ligneCourante + " est un entier");
	    }
	    catch (NumberFormatException e) {
		try {
		    // tentative de conversion en flottant :
		    unFlottant = Double.parseDouble(ligneCourante);
		    sortie.println("=> " + ligneCourante + " est un flottant");
		}
		catch (NumberFormatException ee) {
		    erreur.println("=> ce n'est ni un entier ni un flottant !");
		}
	    }
	}
	entre.close();
    }    
}
