import java.awt.image.WritableRaster;

class MandelbrotParBande implements Runnable
{
    private double xMin,yMinBande,xPas,yPas;
    private int jMinBande,xResolution,yResolutionBande,profondeur;
    private WritableRaster tamponImage;
   
    MandelbrotParBande(double xMin,double yMinBande,
		       double xPas,double yPas,int jMinBande,
		       int xResolution,int yResolutionBande,
		       int profondeur,WritableRaster tamponImage)
    {
	this.xMin = xMin;
	this.yMinBande = yMinBande;
	this.xPas = xPas;
	this.yPas = yPas;
	this.jMinBande = jMinBande;
	this.xResolution = xResolution;
	this.yResolutionBande = yResolutionBande;
	this.profondeur = profondeur;
	this.tamponImage = tamponImage;
    }

    public void run()
    {
        // La primitive de calcul d'une bande de la fractale :
        double rC,iC;         // Parties reelles et imaginaires de C
        double rZ,iZ;         // Parties reelles et imaginaires de Z
        double rZ2,iZ2,rZxiZ;
        int iter,i,j,jMaxBande = jMinBande+yResolutionBande;
        double couleur;
        
        for(j=jMinBande , iC=yMinBande ; j<jMaxBande ; j++ , iC+=yPas)
            for (i=0 , rC=xMin ; i<xResolution ; i++ , rC+=xPas) {
                rZ = 0.0;
                iZ = 0.0;
                iter = 0;
                do {
                    rZ2 = rZ * rZ;
                    iZ2 = iZ * iZ;
                    rZxiZ = rZ * iZ;        
                    rZ = rZ2 - iZ2 + rC;
                    iZ = 2 * rZxiZ + iC;
                    iter++;
                } while ((iter < profondeur) && ((rZ2 + iZ2) <= 4));
                couleur = (iter*255)/profondeur;
                tamponImage.setPixel(i,j,new double[]{couleur,couleur,couleur});
            }
    }
}
