import java.net.*;
import java.io.*;

abstract class ClientAbstrait
{
    Socket maSocket;
    BufferedReader entre;
    PrintWriter sortie;
 
    ClientAbstrait(String adresseCible,int portCible)
    {
	try {
	    maSocket = new Socket(adresseCible,portCible);
	    entre = new BufferedReader(new InputStreamReader(maSocket.getInputStream()));
	    sortie = new PrintWriter(maSocket.getOutputStream(),true);
	}
        catch (UnknownHostException uneException) {
            System.err.println("La machine " + adresseCible + " est inaccessible !");
            System.exit(1);
        }
        catch (ConnectException uneException) {
            System.err.println("Connexion au port " + portCible + " refuse !");
            System.exit(2);
        }
       catch (IllegalArgumentException uneException) {
            System.err.println(portCible + " n'est pas un port valide !");
            System.exit(3);
        }
        catch (SocketException uneException) {
            System.err.println("Erreur  l'tablissement de la socket !");
            System.exit(4);
        }
        catch (IOException uneException) {
            System.err.println("Erreur de lecture du flux d'entre.");
            System.exit(5);
	}
    }

    abstract void traitement();

    void fermeture()
    {
	try {
	    entre.close();
	    sortie.close();
	    maSocket.close();
	}
	catch (IOException uneException) {
	    System.err.println("Problme  la fermeture des flux ou de la socket !");
            System.exit(6);
	}
    }
}
