import java.net.*;
import java.io.*;

class ClientWeb extends ClientAbstrait
{
    URL url;
    StreamTokenizer analyseur;
    
    ClientWeb(URL url)
    {
	super(url.getHost(),url.getPort());
	// ajout d'un analyseur lexical et d'une rfrence sur l'URL
	// du document  traiter, au constructeur par dfaut hrit de
	// la classe abstraite :
	analyseur = new StreamTokenizer(entre);
	this.url = url;
    }
    
    void traitement()
    {
	// implmentation de la mthode abstraite de la classe ClientAbstrait :
	boolean hyperlien = false;
	// soumission de la requte HTTP au serveur interrog :
	sortie.println("GET "+ url.toString() + "\r\n");
	// traitement de la rponse HTTP en provenance du serveur :
	try {
	    while (analyseur.nextToken() != StreamTokenizer.TT_EOF) {
		// boucler sur l'analyse de l'unit lexicale (le lexme)
		// courante, tant qu'il ne s'agit pas de la fin du flux
		// d'entre en provenance du serveur :
		switch (analyseur.ttype) {
		case StreamTokenizer.TT_WORD:
		    // si le lexme courant est un mot de type HREF ou/ SRC,
		    // le lexme suivant commenant par une simple ou une
		    // double quote est un hyperlien. On positionne donc le
		    // drapeau  la valeur logique true :
		    if (analyseur.sval.equalsIgnoreCase("href") || 
			analyseur.sval.equalsIgnoreCase("src") || 
			analyseur.sval.equalsIgnoreCase("action"))
			hyperlien = true;
		    break;

		case '"':
		case '\'':
		    // cas o le lexme commence par une simple ou une double
		    // quote :
		    if (hyperlien) {
			try {
			    // si le drapeau "hyperlien" est positionn  la
			    // valeur "true", il s'agit a priori d'une URL. On
			    // peut alors essayer d'instancier un objet URL
			    // pour vrifier sa validit :
			    System.out.println(new 
				URL(analyseur.sval).toString());
			} catch (MalformedURLException uneException) {
			    try {
				// dans ce cas, il peut s'agir d'un hyperlien
				// relatif. On cherche  le complter et 
				// rinstancier un objet URL :
				System.out.println(new 
				    URL(url.toString()+analyseur.sval).toString());
			    } catch (MalformedURLException autreException) {}
			} finally {
			    // aprs lecture de l'URL, le drapeau "hyperlien"
			    // est remis  la valeur false :
			    hyperlien = false;
			}
		    }
		    break;
		case '=':
		    // dans le cas o le lexme courant est un "=", c'est le
		    // statut quo, on ne repositionne pas le drapeau
		    // "hyperlien" :
		    break;
		default:
		    // dans tous les autres cas, le drapeau "hyperlien" est
		    // remis  la valeur false :
		    hyperlien = false;
		}
	    }
	}
        catch (IOException uneException) {
            System.err.println("Erreur de lecture du flux d'entre.");
        }
    }
    
    public static void main (String[] arguments) throws MalformedURLException
    {
	ClientWeb desHyperliens = new ClientWeb(new URL(arguments[0]));
	desHyperliens.traitement();
	desHyperliens.fermeture();
    }
}
