import java.net.*;
import java.io.*;

class EnvoiUDP
{
    private final static int NOMBRE_D_ENVOIS = 240;
    InetAddress adresseCible;
    int portCible;
    
    EnvoiUDP(String adresseCible,int portCible) throws UnknownHostException
    {
	this.adresseCible = InetAddress.getByName(adresseCible);
	this.portCible = portCible;
    }
    
    private byte[] forgerLeMessage(int tailleDatagramme)
    {
	// cette mthode remplit un tableau d'octets par des squences de
	// chiffres dcimaux stocks sous forme d'octets (la taille totale du
	// tableau vaut "tailleDatagramme") :
	byte[] rsultat = new byte[tailleDatagramme];
	for (int i=0 ; i<tailleDatagramme ; i++)
	    // Rappel : 48 est le code ASCII du chiffre 0, 49 celui du chiffre
	    // 1,... et 57 celui du chiffre 9 :
	    rsultat[i] = (byte) (48 + i%10);
	return rsultat;
    }
    
    void envoyer(int tailleDatagramme) throws SocketException, IOException
    {
	// la mthode envoyer gnre un datagramme  partir d'un tableau de
	// "tailleDatagramme" octets, puis boucle un nombre de fois gal 
	// "NOMBRE_D_ENVOIS" sur son envoi par la mthode send d'une instance
	// "anonyme" de DatagramSocket :
	DatagramSocket laSocketUDP = new DatagramSocket();
	DatagramPacket leDatagramme = 
	    new DatagramPacket(forgerLeMessage(tailleDatagramme),tailleDatagramme,
			       adresseCible,portCible);
	
	for(int i=1 ; i<=NOMBRE_D_ENVOIS ; i++) {
	    laSocketUDP.send(leDatagramme);
	    System.out.println("datagramme " + i + " / " + tailleDatagramme + " octets");
	}
    }

    public static void main (String[] arguments) 
	throws UnknownHostException, SocketException, IOException
    {
	new EnvoiUDP(arguments[0],Integer.parseInt(arguments[1])).
	    envoyer(Integer.parseInt(arguments[2]));
    }
}
