import java.net.*;
import java.io.*;

class ScannerDePortsTCPMultithreads implements Runnable
{
    private final static int NB_THREADS_MAX = 25;
    private String adresse;
    private int portMin,portMax;

    ScannerDePortsTCPMultithreads(String adresse,int portMin,int portMax)
    {
	this.adresse = adresse;
	this.portMin = portMin;
	this.portMax = portMax;
    }

    public void run()
    {
	Socket maSocket;
	
	for(int port=portMin ; port <= portMax ; port++) {
	    try {
		maSocket = new Socket(adresse,port);
		System.out.println(port + "/tcp open sur " + adresse);
	    }
	    catch (UnknownHostException uneException) {
		System.err.println("La machine " + adresse + " est inaccessible !");
		System.exit(1);
	    }
	    catch (ConnectException uneException) {
	    }
	    catch (IOException uneException) {
		System.err.println("Erreur de lecture du flux d'entre.");
		System.exit(2);		
	    }
	    catch (IllegalArgumentException uneException) {
		System.err.println("Vous tes sorti de l'intervalle 1, ..., 65535.");
		System.exit(3);
	    }
	}
    }

    public static void main (String[] arguments) throws InterruptedException
    {
	String cible = arguments[0];
	int portMax = Integer.parseInt(arguments[1]);
	int nbThreadsMax = Math.min(NB_THREADS_MAX,portMax);
	int tranche = (int) Math.floor((double)portMax/(double)nbThreadsMax);

	long dateDbut = System.currentTimeMillis(); // mesure du temps

	Thread[] mesScans = new Thread[nbThreadsMax];
	for (int i=0 ; i < nbThreadsMax ; i++) {
	    mesScans[i] = new 
		Thread(new ScannerDePortsTCPMultithreads(cible,i*tranche+1,(i+1)*tranche));
            mesScans[i].start();
	}
	
	for (int i=0 ; i< nbThreadsMax ; i++) {
            mesScans[i].join();
	}
	long dateFin = System.currentTimeMillis(); // mesure du temps
	System.err.println("Temps d'excution = " + (dateFin-dateDbut) + " ms");
    }
}
