import java.net.*;
import java.util.*;
import java.io.*;

class ServeurDeMotsDePasse
{
    // liste (non exhaustive) des caractres admissibles dans un mot de passe :
    private final static char[] caractresAdmissibles = ( "ABCDEFGHIJKLMNOP" +
	"QRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/" ).toCharArray();
    private final static int LONGUEUR_MOT_DE_PASSE=8;
    private ServerSocket leServeur;
    private Random gnrateurAlatoire;

    ServeurDeMotsDePasse(int port) throws IOException
    {
        // lanons le serveur sur le port identifi par le numro "port" :
        leServeur = new ServerSocket(port);
        System.out.println("Un serveur est lanc sur le port " + leServeur.getLocalPort());
	// et instancions le gnrateur alatoire :
	gnrateurAlatoire = new Random();
    }

    char[] gnrerUnMotDePasse()
    {
	// le mot de passe est compos de 8 (LONGUEUR_MOT_DE_PASSE)
	// caractres tirs pseudo-alatoirement au sort dans le
	// tableau des caractres qui a t dfini statiquement
	// prcdemment :
	char[] rsultat = new char[LONGUEUR_MOT_DE_PASSE];
	for(int i=0 ; i<LONGUEUR_MOT_DE_PASSE ; i++)
	  rsultat[i] = caractresAdmissibles[gnrateurAlatoire.
				   nextInt(caractresAdmissibles.length)];
	return rsultat;
    }

    void lancer() throws IOException
    {
	Socket uneConnexionEtablie;
	PrintWriter sortie;

	// boucle de traitement infinie :
	while (true) {
	    // Mettons le serveur en attente d'une connexion sur ce port :
	    uneConnexionEtablie = leServeur.accept();
 	    System.out.println(new Date() + " => " +
 			       uneConnexionEtablie.getInetAddress() + " (" +
 			       uneConnexionEtablie.getPort() + ")");
	    // une fois la connexion tablie, il faut mettre le mot de passe :
	    sortie = new PrintWriter(uneConnexionEtablie.getOutputStream(),true);
	    sortie.println(gnrerUnMotDePasse());
	    sortie.flush();
	    sortie.close();
	    // puis fermer la connexion aprs avoir vid et ferm le
	    // tampon d'criture associ  la socket...
	    uneConnexionEtablie.close();
	}
    }

    public static void main (String[] arguments) throws IOException
    {
	new ServeurDeMotsDePasse(Integer.parseInt(arguments[0])).lancer();
    }
}
