import java.net.*;
import java.io.*;

class ServeurReseauSimpliste
{
    private int port;
    private ServerSocket leServeur;
    private Socket uneConnexionEtablie;
    
    ServeurReseauSimpliste(int port)
    {
	this.port = port;
    }

    void lancer() throws IOException
    {
	// Lanons le serveur sur le port identifi par le numro "port" :
	leServeur = new ServerSocket(port);
	System.out.println("Un serveur est lanc sur le port " + leServeur.getLocalPort());
	// Mettons le serveur en attente d'une connexion sur ce port :
	uneConnexionEtablie = leServeur.accept();
	System.out.println("Contact tabli entre :\n- le serveur " + 
			   uneConnexionEtablie.getLocalAddress() + ", sur le port " + 
			   uneConnexionEtablie.getLocalPort() +
			   "\n- et le client " + uneConnexionEtablie.getInetAddress() +
			   ", sur le port " + uneConnexionEtablie.getPort());
    }

    void arrter() throws IOException
    {
	uneConnexionEtablie.close();
	leServeur.close();
    }
    
    public static void main (String[] arguments) throws IOException
    {
	// instanciation d'un nouveau serveur sur le port pass en argument de
	// la ligne de commande :
	ServeurReseauSimpliste monServeur = 
	    new ServeurReseauSimpliste(Integer.parseInt(arguments[0]));
	monServeur.lancer();
	monServeur.arrter();	
    }
}
